
library(ggplot2)
library(tidyverse)
library(dplyr)
library(ggpubr)
library(ggridges)
library(lubridate)
library(lomb)

##lomb scargle analysis 


# load the fonctions 
source("C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/Data availability/periodlomb.R")
source("C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/Data availability/periodlombmar.R")

setwd("C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/Data availability")

lam5jan<-periodlomb("MyRunCtM005Jan19.txt","LAM5","periodLam5jan19")
lam6jan<-periodlomb("MyRunCtM006Jan19.txt","LAM6","periodLam6jan19")

lam5feb<-periodlomb("MyRunCtM005Feb19.txt" ,"LAM5","periodLam5feb19")
lam6feb<-periodlomb("MyRunCtM006Feb19.txt","LAM6","periodLam6feb19")

lam5mar<-periodlomb( "MyRunCtM005Mar19.txt","LAM5","periodLam5mar19")
lam6mar<-periodlomb("MyRunCtM006Mar19.txt","LAM6","periodLam6mar19")

lam5apr<-periodlomb("MyRunCtM005Apr119.txt","LAM5","periodLam5apr19")
lam6apr<-periodlomb("MyRunCtM006Apr119.txt","LAM6","periodLam6apr19")

lam5apr2<-periodlomb( "MyRunCtM005Apr219.txt","LAM5","periodLam5apr219")
lam6apr2<-periodlomb("MyRunCtM006Apr219.txt","LAM6","periodLam6apr219")

lam5may<-periodlomb( "MyRunCtM005May19.txt","LAM5","periodLam5may19")
lam6may<-periodlomb("MyRunCtM006May19.txt","LAM6","periodLam6may19")

lam5jun<-periodlomb("MyRunCtM005Jun19.txt","LAM5","periodLam5jun19")
lam6jun<-periodlomb( "MyRunCtM006Jun19.txt","LAM6","periodLam6jun19")
lam17jun<-periodlomb("MyRunCtM017Jun19.txt","LAM17","periodLam17jun19")
lam18jun<-periodlomb("MyRunCtM018Jun19.txt","LAM18","periodLam18jun19")

lam5aug<-periodlomb( "MyRunCtM005Aug19.txt","LAM5","periodLam5aug19")
lam6aug<-periodlomb("MyRunCtM006Aug19.txt","LAM6","periodLam6aug19")
lam17aug<-periodlomb("MyRunCtM017Aug19.txt","LAM17","periodLam17aug19")
lam18aug<-periodlomb("MyRunCtM018Aug19.txt","LAM18","periodLam18aug19")

lam5sep<-periodlomb("MyRunCtM005Sep119.txt","LAM5","periodLam5sep19")
lam6sep<-periodlomb( "MyRunCtM006Sep119.txt","LAM6","periodLam6sep19")
lam17sep1<-periodlomb( "MyRunCtM017Sep119.txt","LAM17","periodLam6sep19")
lam18sep1<-periodlomb("MyRunCtM018Sep119.txt","LAM18","periodLam18sep19")

lam5sep2<-periodlomb( "MyRunCtM005Sep219.txt","LAM5","periodLam5sep219")
lam6sep2<-periodlomb("MyRunCtM006Sep219.txt","LAM6","periodLam6sep219")
lam17sep2<-periodlomb("MyRunCtM017Sep219.txt","LAM17","periodLam17sep219")
lam18sep2<-periodlomb("MyRunCtM018Sep219.txt","LAM18","periodLam18sep219")

lam5oct<-periodlomb( "MyRunCtM005Oct19.txt","LAM5","periodLam5oct19")
lam6oct<-periodlomb("MyRunCtM006Oct19.txt","LAM6","periodLam6oct19")
lam17oct<-periodlomb("MyRunCtM017Oct19.txt","LAM17","periodLam17oct19")
lam18oct<-periodlomb("MyRunCtM018Oct19.txt","LAM18","periodLam18oct19")

lam5nov<-periodlomb( "MyRunCtM005Nov19.txt","LAM5","periodLam5nov19")
lam6nov<-periodlomb("MyRunCtM006Nov19.txt","LAM6","periodLam6nov19")
lam17nov<-periodlomb( "MyRunCtM017Nov19.txt","LAM17","periodLam17nov19")
lam18Nov<-periodlomb("MyRunCtM018Nov19.txt","LAM18","periodLam18Nov")

lam5dec<-periodlomb("MyRunCtM005Dec19.txt","LAM5","periodLam5dec19") 
lam6dec<-periodlomb("MyRunCtM006Dec19.txt","LAM6","periodLam6dec19")  
lam17dec<-periodlomb("MyRunCtM017Dec19.txt","LAM17","periodLam17dec19")
lam18dec<-periodlomb("MyRunCtM018Dec19.txt" ,"LAM18","periodLam18dec19")  

lam5dec<-periodlomb("MyRunCtM005Dec18.txt","LAM5","periodLam5dec19")
lam6dec18<-periodlomb("MyRunCtM006Dec18.txt","LAM6","periodLam6dec18")   


#########################################################################################

#process activity data 

ramfjord<-read.csv( "C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/Data availability/monthly activity ramfjord centered.csv" ,header=T)
ram<-subset(ramfjord,activity!="not valid"&alive=="y"& Depth=="deep"& stage!="")

j<-vector()

for (i in 1:48){
  j[i]<-paste("time",48+i,sep="")}


ram2<-ram[12:59]

colnames(ram2)<-j

Ram<-cbind(ram,ram2)


Ap1<-colMeans(subset(Ram,month=="aprilI19")[,12:107],na.rm=T)
Ap2<-colMeans(subset(Ram,month=="aprilII19")[,12:107])
May<-colMeans(subset(Ram,month=="May-19")[,12:107])
Jun<-colMeans(subset(Ram,month=="Jun-19")[,12:107])


Aug<-colMeans(subset(Ram,month=="Aug-19")[,12:107])
Se1<-colMeans(subset(Ram,month=="septemberI19")[,12:107])
Se2<-colMeans(subset(Ram,month=="septemberII19")[,12:107])
Oct<-colMeans(subset(Ram,month=="Oct-19")[,12:107])
Nov<-colMeans(subset(Ram,month=="Nov-19")[,12:107])
Dec<-colMeans(subset(Ram,month=="Dec-19")[,12:107])



hour<-format( seq.POSIXt(as.POSIXct(Sys.Date()), as.POSIXct(Sys.Date()+2), by = "30 min"),"%Y-%m-%d %H%M", tz="GMT")
hour<-hour[1:96]

new<-cbind(hour,Ap1,Ap2,May,Jun,Aug,Se1,Se2,Oct,Nov,Dec)
new<-data.frame(new)
new$hour<-as.POSIXct(new$hour,tz="GMT","%Y-%m-%d %H%M")

new2<-new%>%gather(month,activity,-hour)
new2$activity<-as.numeric(new2$activity)
new2$month<-factor(new2$month,levels=c("Ap1","Ap2","May","Jun","Aug","Se1","Se2","Oct","Nov","Dec"))

#plot activity actogram 
a<-ggplot(new2, aes(x = hour, y =month , height = activity)) +
  geom_density_ridges(stat="identity",scale=1,fill="grey",color="grey") +
  theme_classic() 



##################################################################################
#plot light actogramm 
light.ram<-read.csv("C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/Data availability/monthly light daily activity centered.csv",header=T,row.names=1 )
ram.light<-cbind(hour,light.ram)


ram.light<-data.frame(ram.light)
ram.light$hour<-as.POSIXct(ram.light$hour,tz="GMT","%Y-%m-%d %H%M")

ram.light2<-ram.light[1:48,]%>%gather(month,light,-hour)
ram.light2$light<-as.numeric(ram.light2$light)

ram.light2<-ram.light2[145:624,] # to not include January to march 
ram.light2$month<-factor(ram.light2$month,levels=c("Ap1","Ap2","May","Jun","Aug","Se1","Se2","Oct","Nov","Dec"))

c<-ggplot(ram.light2, aes(x = hour, y =month , height = light)) +
  geom_density_ridges(stat="identity",scale=1,fill="black",color="black") +
  theme_classic()


########################################################################
#plot activity PNmax 
pnmax<-aggregate(as.numeric(data2[, 20]), list(data2$num), mean,na.rm=T)

colnames(pnmax)<-c("num","value")
pnmax$value2<-(pnmax$value-min(pnmax$value))/(max(pnmax$value-min(pnmax$value)))

b<-ggplot(pnmax[4:13,], aes(x=num, y=value2)) + 
  geom_bar(stat = "identity",fill="grey",width=0.5) +
  # scale_y_continuous(breaks =seq(0,0.15,0.02),"pnmax")+
  scale_x_discrete(labels=new.num)+
  coord_cartesian(ylim = c(0, 1)) +   
  xlab("")+
  theme_classic()

#############################################################################
# Rayleigh test 
ramfjord<-read.csv( "C:/Users/Estelle/OneDrive - UiT Office 365/sauvegarde/AZFP ramfjord/paper3/activity/monthly activity ramfjord centered.csv" ,header=T)
ram<-subset(ramfjord,activity!="not valid"&alive=="y"& Depth=="deep"& stage!="")

Ap1<-colSums(subset(ram,month=="aprilI19")[,12:59],na.rm=T)
Ap2<-colSums(subset(ram,month=="aprilII19")[,12:59])
May<-colSums(subset(ram,month=="May-19")[,12:59])

Jun<-colSums(subset(ram,month=="Jun-19")[,12:59])
Aug<-colSums(subset(ram,month=="Aug-19")[,12:59])
Se1<-colSums(subset(ram,month=="septemberI19")[,12:59])
Se2<-colSums(subset(ram,month=="septemberII19")[,12:59])
Oct<-colSums(subset(ram,month=="Oct-19")[,12:59])
Nov<-colSums(subset(ram,month=="Nov-19")[,12:59])
Dec<-colSums(subset(ram,month=="Dec-19")[,12:59])


hour<-format( seq.POSIXt(as.POSIXct(Sys.Date()), as.POSIXct(Sys.Date()+2), by = "30 min"),"%Y-%m-%d %H%M", tz="GMT")
hour<-hour[1:48]


new.circ<-cbind(hour,Ap1,Ap2,May,Jun,Aug,Se1,Se2,Oct,Nov,Dec)
new.circ<-data.frame(new.circ)
new.circ$hour<-as.POSIXct(new.circ$hour,tz="GMT","%Y-%m-%d %H%M")

ram.circ.data <- new.circ[1:48,]
ram.circ.data$hour<-format(ram.circ.data$hour,format="%H:%M:%S")


# convert time to character, add function for h:m:s to decimal, add decimal to dataframe
ram.circ.data$hour <- as.character(ram.circ.data[["hour"]])


hhmmss2dec <- function(x) {
  xlist <- strsplit(x,split=":")
  h <- as.numeric(sapply(xlist,"[",1))
  m <- as.numeric(sapply(xlist,"[",2))
  s <- as.numeric(sapply(xlist,"[",3))
  xdec <- h+(m/60)+(s/60/60)
  return(xdec)
}

ram.circ.data$time.dec <- hhmmss2dec(ram.circ.data$hour) 

ram.circ.data$Ap1<-as.integer(ram.circ.data$Ap1)
ram.circ.data$Ap2<-as.integer(ram.circ.data$Ap2)
ram.circ.data$May<-as.integer(ram.circ.data$May)
ram.circ.data$Jun<-as.integer(ram.circ.data$Jun)
ram.circ.data$Aug<-as.integer(ram.circ.data$Aug)
ram.circ.data$Se1<-as.integer(ram.circ.data$Se1)
ram.circ.data$Se2<-as.integer(ram.circ.data$Se2)

ram.circ.data$Oct<-as.integer(ram.circ.data$Oct)
ram.circ.data$Nov<-as.integer(ram.circ.data$Nov)
ram.circ.data$Dec<-as.integer(ram.circ.data$Dec)



#expands dataframe using "values" representing beam breaks, outputs a vector of time.dec; make this "4:5" to plot in ggplot
ram.circ.data.Ap.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Ap1),12]
ram.circ.data.Apr.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Ap2),12]
ram.circ.data.May.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$May),12]
ram.circ.data.jun.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Jun),12]
ram.circ.data.aug.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Aug),12]

ram.circ.data.sep.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Se1),12]
ram.circ.data.sep1.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Se2),12]
ram.circ.data.oct.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Oct),12]
ram.circ.data.nov.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Nov),12]
ram.circ.data.dec.expanded<- ram.circ.data[rep(seq(nrow(ram.circ.data)), ram.circ.data$Dec),12]


library(circular)

ram.circ.Ap <- circular(ram.circ.data.Ap.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.Ap)
ram.circ.mean.Ap<- mean(ram.circ.Ap)
print(ram.circ.mean.Ap) #12.54248
sd.circular(ram.circ.Ap)#2.10533
rho.circular(ram.circ.Ap) #0.1085171

ram.circ.Apr <- circular(ram.circ.data.Apr.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.Apr)
ram.circ.mean.Apr<- mean(ram.circ.Apr)
print(ram.circ.mean.Apr) #12.8594

sd.circular(ram.circ.Apr) # 2.416997
rho.circular(ram.circ.Apr) #0.0538832

ram.circ.May <- circular(ram.circ.data.May.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.May)
ram.circ.mean.May<- mean(ram.circ.May)
print(ram.circ.mean.May) #0.01188687
sd.circular(ram.circ.May) # 2.261073
rho.circular(ram.circ.May) #0.07759702

ram.circ.jun <- circular(ram.circ.data.jun.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.jun)
ram.circ.mean.jun<- mean(ram.circ.jun)
print(ram.circ.mean.jun) #3.01488
sd.circular(ram.circ.jun) #2.745327
rho.circular(ram.circ.jun) #0.02308874

ram.circ.aug <- circular(ram.circ.data.aug.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")

rayleigh.test(ram.circ.aug)
ram.circ.mean.aug<- mean(ram.circ.aug)
print(ram.circ.mean.aug) #3.143374
sd.circular(ram.circ.aug) #2.626564
rho.circular(ram.circ.aug) #0.0317641

ram.circ.sep <- circular(ram.circ.data.sep.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.sep)
ram.circ.mean.sep<- mean(ram.circ.sep)
print(ram.circ.mean.sep) # 0.4743561
sd.circular(ram.circ.sep) #2.014279
rho.circular(ram.circ.sep) #0.1315117

ram.circ.sep1 <- circular(ram.circ.data.sep1.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.sep1)
ram.circ.mean.sep1<- mean(ram.circ.sep1)
print(ram.circ.mean.sep1) #13.52958
sd.circular(ram.circ.sep1) #2.782525
rho.circular(ram.circ.sep1) #0.02083289

ram.circ.oct <- circular(ram.circ.data.oct.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")

rayleigh.test(ram.circ.oct)
ram.circ.mean.oct<- mean(ram.circ.oct)
print(ram.circ.mean.oct) #12.6082
sd.circular(ram.circ.oct) #2.400045

rho.circular(ram.circ.oct) # 0.05612864

ram.circ.nov <- circular(ram.circ.data.nov.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")

rayleigh.test(ram.circ.nov)
ram.circ.mean.nov<- mean(ram.circ.nov)
print(ram.circ.mean.nov) #12.86958
sd.circular(ram.circ.nov) #2.472317
rho.circular(ram.circ.nov) # 0.0470674

ram.circ.dec <- circular(ram.circ.data.dec.expanded, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
rayleigh.test(ram.circ.dec)
ram.circ.mean.dec<- mean(ram.circ.dec)
print(ram.circ.mean.dec) #11.32549
sd.circular(ram.circ.dec) #2.473521

rho.circular(ram.circ.dec) #0.04692746 

ram.means<- c(12.54248, 12.8594, 0.01188687, 3.01488, 3.143374, 0.4743561, 13.52958, 12.6082,12.86958,11.32549)
ram.means.circ <- circular(ram.means, type = "angles", units = "hours", template = "clock24", modulo = "2pi")
ram.rho <- c(rho.circular(ram.circ.Ap),rho.circular(ram.circ.Apr),rho.circular(ram.circ.May),rho.circular(ram.circ.jun), rho.circular(ram.circ.aug),rho.circular(ram.circ.sep),rho.circular(ram.circ.sep1),rho.circular(ram.circ.oct),rho.circular(ram.circ.nov),rho.circular(ram.circ.dec))

# add rho values to "y" vector and add to arrows.circular, label with months
postscript(file="clock.eps")
plot.circular(ram.means.circ, cex=0, units = "hours", template = "clock24", bins=24, stack=T, sep = 0.05, shrink=1.15, col="lightskyblue3") #make etive "red" or "brown2"
arrows.circular(ram.means.circ, y=ram.rho*4.5, length=0.075, angle=25, col="lightskyblue3", lwd=2)
dev.off()



name<-c("D","E","F","G","I","J","K","L","M","N")
rho<-as.data.frame(cbind(name,ram.rho))
rho$ram.rho<-as.numeric(rho$ram.)

f<-ggplot(rho, aes(x=name, y=ram.rho)) + 
  geom_bar(stat = "identity",fill="grey",width=0.5) +
  scale_y_continuous(breaks =seq(0,0.15,0.02),"rho")+
  scale_x_discrete(labels=new.num)+
  coord_cartesian(ylim = c(0, 0.15)) +   
  xlab("")+
  theme_classic()
